# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.column_metadata import ColumnMetadata  # noqa: F401,E501


class CodeListMetaData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'column_count': 'int',
        'row_count': 'int',
        'columns': 'list[ColumnMetadata]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'column_count': 'columnCount',
        'row_count': 'rowCount',
        'columns': 'columns'
    }

    def __init__(self, id=None, name=None, column_count=None, row_count=None, columns=None):  # noqa: E501
        """CodeListMetaData - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._column_count = None
        self._row_count = None
        self._columns = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if column_count is not None:
            self.column_count = column_count
        if row_count is not None:
            self.row_count = row_count
        if columns is not None:
            self.columns = columns

    @property
    def id(self):
        """Gets the id of this CodeListMetaData.  # noqa: E501


        :return: The id of this CodeListMetaData.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CodeListMetaData.


        :param id: The id of this CodeListMetaData.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CodeListMetaData.  # noqa: E501


        :return: The name of this CodeListMetaData.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CodeListMetaData.


        :param name: The name of this CodeListMetaData.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def column_count(self):
        """Gets the column_count of this CodeListMetaData.  # noqa: E501


        :return: The column_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._column_count

    @column_count.setter
    def column_count(self, column_count):
        """Sets the column_count of this CodeListMetaData.


        :param column_count: The column_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._column_count = column_count

    @property
    def row_count(self):
        """Gets the row_count of this CodeListMetaData.  # noqa: E501


        :return: The row_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._row_count

    @row_count.setter
    def row_count(self, row_count):
        """Sets the row_count of this CodeListMetaData.


        :param row_count: The row_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._row_count = row_count

    @property
    def columns(self):
        """Gets the columns of this CodeListMetaData.  # noqa: E501


        :return: The columns of this CodeListMetaData.  # noqa: E501
        :rtype: list[ColumnMetadata]
        """
        return self._columns

    @columns.setter
    def columns(self, columns):
        """Sets the columns of this CodeListMetaData.


        :param columns: The columns of this CodeListMetaData.  # noqa: E501
        :type: list[ColumnMetadata]
        """

        self._columns = columns

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CodeListMetaData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
